/**
 *    DataAPPs ServiceWorker for notification control
 *    
 *    Paste this JS file to domain root folder!
 *    
 *    @author  DataAPPs
 *    @link    https://www.websocket.cz
 *    @version 1.0.2
 */

self.ntfCache = {};

self.addEventListener('install', (e) => {
	self.skipWaiting();
});

self.addEventListener('activate', (e) => {
	e.waitUntil(self.clients.claim());
});

self.addEventListener('message', (e) => {
	if (e.data && e.data.action && e.data.message && e.data.action == 'requestNotification') {
		let ntf = e.data.message;
		let out = {action: null, id: null, allowed: false};
		
		if (ntf && ntf['id'] > '') {
			out.id = ntf['id'];
		};
		
		if (out.id > '' && self.ntfCache && self.ntfCache[out.id] == undefined) {
			self.ntfCache[out.id] = ntf;
			out.action = 'displayNotification';
			out.allowed = true;
			e.source.postMessage(out);
		};
	}
});
